/*
 * Copyright European Organization for Nuclear Research (CERN)
 * All rights reserved
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	04-Feb-2010
 */

#include "cbody.h"
#include "engine.h"

/** return name of body */
const std::string& CBody::name() const
{
	return gbody->name();
} // name

/** return name of body */
const char* CBody::cname() const
{
	return gbody->cname();
} // cname

/** Inside2D version before use please take care of incBodyCheckId2D() */
bool CBody::inside2D(
#ifdef EXPERIMENTAL
			GeometryEngine* engine,
#endif
			 const double  x, const double  y, const double  z,
			 const double dx, const double dy, const double dz)
{
	if (vbody->nC==0 && vbody->location!=GBody::Location::OVERLAP)
		// FIXME
		return (bool)vbody->location;
	if (*gCheckId!=_checkId) {
#ifdef EXPERIMENTAL
		bool withinAcc;
		checkInside = gbody->inside2D(x,y,z, dx,dy,dz, vbody->acc, &withinAcc);
		if (withinAcc)
			engine->addProximity(this);
#else
		checkInside = gbody->inside2D(x,y,z, dx,dy,dz, vbody->acc);
#endif
		checked();
	}
	return checkInside;
} // inside2D

