/*
 * Copyright European Organization for Nuclear Research (CERN)
 * All rights reserved
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	11-Oct-2016
 */

#ifndef __GEOMETRY_TETRAMESHIO_H
#define __GEOMETRY_TETRAMESHIO_H

#include "tool/stream.h"

class TetraMesh;

/**
 * TetraMesh I/O helper class
 */
class TetraMeshIO : public Stream {
public:
	TetraMeshIO() : Stream() {}
	TetraMeshIO(const char *name, Stream::IO io=Stream::IO::Read, bool bin=false)
		: Stream(name, io, bin) {}
	virtual ~TetraMeshIO() {close();}

	bool	read(TetraMesh& mesh);
//	bool	write(TetraMesh& mesh);

#if 0
	/** prepare a valid DXF header */
	void writeHeader();
	/** prepare a valid DXF footer */
	void writeFooter();

	/** write a mesh and check if header is needed
	 * @param mesh mesh to be written
	 * @param color color code to use
	 * @param name override name to use
	 */
	virtual void write(Mesh& mesh, int color=0, const char *name=NULL);

private:
	/** write a vector in DXF format */
	void writeVector(const double x, const double y, const double z);
	void writeVector(const Vector& v)	{ writeVector(v.x, v.y, v.z); }
#endif

private:
	bool	_readAscii(TetraMesh& mesh);
	bool	_readBinary(TetraMesh& mesh);
}; // TetraMeshIO

#endif
