/*
 * Copyright European Organization for Nuclear Research (CERN)
 * All rights reserved
 *
 * Please look at the supplied documentation for the user's
 * license
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	01-Apr-2011
 */
#ifndef __GLMESH_H
#define __GLMESH_H

#include <GL/gl.h>

#include "os.h"
#include "graph/color.h"
#include "geometry/mesh.h"

// ================================== GLMesh ===================================
class GLMesh { //: GLObject {
private:
	Mesh*	mesh;		/** Mesh to draw		*/
	bool	fill;		/** Fill Faces			*/

public:
static	bool	drawNormals;	/** Draw Normals		*/
static	bool	drawVertices;	/** Draw vertices		*/
static	bool	drawEdges;	/** Draw Edges			*/
static	bool	drawFaces;	/** Draw Faces			*/

static	double	normalLength;	/** Normal vector length	*/
static	double	foldCos;	/** Cosine that face is fold	*/

static	Color	normalColor;	/** Normal vector color		*/
static	Color	edgeColor;	/** Edge color			*/
static	Color	vertexColor;	/** Vertex color		*/

public:
	GLMesh(Mesh* amesh=NULL)
		: // GLObject(),
		  fill(TRUE)
		{ mesh = amesh; } //setColor(0.8, 0.8, 0.8); }

virtual	~GLMesh() {}

	void setMesh(Mesh* amesh)	{ mesh = amesh; }

virtual	void draw(GLenum mode);
}; // class GLMesh

#endif
