/*
 * Copyright European Organization for Nuclear Research (CERN)
 * All rights reserved
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 */

#ifndef __VIEWER_EXPORT_LAYER_H
#define __VIEWER_EXPORT_LAYER_H

#include "os.h"
#include "layer.h"

class ExportBase;
class VBody;

/* ================================ VoxelLayer ============================== */
class ExportLayer : public Layer {
public:
	ExportLayer(const Geometry& g, GeometryKernel& k, GeometryViewer& v) : Layer(g, k, v) {}

	/* set/get */
	void	operator()(const char *filename);
	void	draw(const dword mask=0);

protected:
	void	exportDXF(const char *filename);
	void	exportSVG(const char *filename);

	void	exportSegments(ExportBase& exporter, VBody *body);
	void	exportSegment(ExportBase& exporter, VBody *body, const int ic, const dword color,
			const double ts, const double xs, const double ys,
			const double te, const double xe, const double ye,
			double *step);
}; // ExportLayer

#endif
